#Following function implements the LoMST algorithm and returns the anomaly indices and number of true detection for a preselected k value and a cut-off value
LoMST=function(selectedk,N){
  nn <- kNN(data, k=selectedk)
  kn=as.matrix(nn$id)
  
  for(i in 1:nrow(data)) 
  { 
    nam<- paste("dist", i, sep = "")
    assign(nam, as.matrix(dist(data[c(i,kn[i,]),])))
  }
  
  sumhist=numeric(nrow(data))
  compare=numeric(nrow(data))
  for(i in 1:nrow(data)){
    d=get(paste("dist", i, sep = ""))
    mat=as.matrix(dino.mst(d))
    d[which(mat== 0)] <- 0
    
    sumhist[i]=sum(d)}
  for(i in 1:nrow(data)){
    compare[i]=sumhist[i]-mean(sumhist[c(kn[i,])])}
  
  summary=as.data.frame(compare)
  summary$obs=c(1:nrow(data))
  sumhistarranged=as.data.frame(arrange(summary,desc(compare)))
  listofoutliers=sumhistarranged$obs[1:N]
  dat$d=c(1:nrow(data))
  required=dat[,c(ncol(dat)-1,ncol(dat))]
  names(required)=c("Outlier status","obs")
  final=as.data.frame(merge(sumhistarranged,required,by=c("obs")))
  final$Outlier_Score=(final$compare-min(final$compare))/(max(final$compare)-min(final$compare))
  finalarranged=as.data.frame(arrange(final,desc(compare)))
  success=as.numeric(table(finalarranged$`Outlier status`[1:N])[2])
  RESULT <- list("anomaly_indices" = listofoutliers, "number_of_true_detection" = success)
  return(RESULT)}