#Loading Required packages

library(fossil)
library(dbscan)
library(dplyr)

#Loading data file 
dat=read.csv("./Datasets/WBC.csv",header=F) #Demonstrated for WBC dataset, user can use their own dataset
dat=dat[!duplicated(dat), ]
data=dat[-c(ncol(dat))]
source('./Codes/BestK.r') #To find out the best K
bestk=BestK(data,dat) #'k' value that returns the best detection performance, selected after trying all of the k-value options from 1-200
#selectedk=43 #Selected visually, we get it using PracticalKvalueselection.R
N=as.data.frame(table(dat[,ncol(dat)]))[2,2] #Cut-off value to evaluate the performance which is set to number of true anomalies for each dataset

#Generating the anomaly indices and number of true detection for 'best k' and 'selected practical k'
source('./Codes/LoMST.r')
LoMST (bestk, N)
#Run the code below for practical K result
#LoMST(selectedk,N)
